Module modARIBGaiji
    Public Const ARIB_MAX As Integer = 494
    Public Const WIN_DVD_FONT As String = "DFPGothicP-W5-AribTrB14"
    Public Const RICHO_FONT As String = "HGPp޼W5AR"
    Public Const DEF_FONT As String = "lr SVbN" '"MS UI Gothic"
    Public Const WIN_DVD_GAIJI_INI As String = "WinDVD_cc_gaiji.ini"
    Public Const UNICODE_GAIJI_INI As String = "UNICODE_cc_gaiji.ini"

    Public uARIB(ARIB_MAX) As ARIB

    Public sFontARIB As String

    Public Structure ARIB
        Public Text As String
        Public Output As Boolean
        Public Used As Boolean
    End Structure

    Public Sub LoadARIBGaijiFont(ByVal sFont As String)
        sFontARIB = sFont
        If sFont = WIN_DVD_FONT Or sFont = RICHO_FONT Then
            LoadARIBGaiji(WIN_DVD_GAIJI_INI)
        Else
            LoadARIBGaiji()
        End If
    End Sub

    Public Sub LoadARIBGaiji(Optional ByVal sFile As String = "cc_gaiji.ini")
        Try
            Dim I As Integer

            For I = 0 To ARIB_MAX
                uARIB(I).Text = ""
                uARIB(I).Output = True
            Next

            oIniGaiji = New cIni(GetAppPath() & "\Gaiji\" & sFile)
            oIniGaiji.Section = "ARIBOp"

            Dim sText() As String = oIniGaiji.GetKeys()

            If sText Is Nothing Then Exit Sub

            Dim sKey() As String
            Dim nGaiji As Integer = UBound(sText)

            oIniGaiji.Section = "ARIBOo"
            For I = 0 To nGaiji
                sKey = Split(sText(I), "=")

                If Val(sKey(0)) >= 9000 And Val(sKey(0)) <= 9000 + ARIB_MAX Then
                    With uARIB(Val(sKey(0)) - 9000)
                        .Text = sKey(1)
                        .Output = Val(oIniGaiji.GetIniString(sKey(0)))
                    End With
                End If
            Next
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try

    End Sub

    Public Sub SaveARIBGaiji()
        Try
            Dim I As Integer
            Dim sCode As String
            For I = 0 To ARIB_MAX
                sCode = CStr(I + 9000)
                oIniGaiji.SetIniString("ARIBOp", sCode, uARIB(I).Text)
                oIniGaiji.SetIniString("ARIBOo", sCode, CInt(uARIB(I).Output))
            Next
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try

    End Sub

    Public Function ReplaceARIBGaiji(ByVal sText As String) As String
        Dim s As String = sText
        Dim I As Integer
        For I = 0 To ARIB_MAX
            With uARIB(I)
                If .Used And .Output Then
                    If Not .Text = "" Then
                        s = Replace(s, "[O" & CStr(I + 9000) & "]", .Text)
                    End If
                End If
            End With
        Next
        Return s
    End Function
End Module
